import malmoenv
from pathlib import Path
import time
from lxml import etree
from threading import Thread
import threading

print(
    """
WARNING:
    This requires two malmo servers to run at ports 9000 and 9001.
    Go to malmo/Minecraft and run
    './launchclient.sh -port 9000 -env'
    and in a second terminal
    './launchclient.sh -port 9001 -env'
    Then call this script.
    """
)

#xml = Path('MalmoPlatform/sample_missions/cliff_walking_1.xml').read_text()
xml = Path('malmo/MalmoEnv/missions/mobchase_two_agents.xml').read_text()

def run(role):
    env = malmoenv.make()
    env.init(xml,
             9000, server='127.0.0.1',
             server2='127.0.0.1', port2=(9000 + role),
             role=role,
             exp_uid="multiagent_test",
             episode=0, resync=0)

    def log(message):
        print('[' + str(role) + '] ' + message)

    log(str(env.action_space))
    log(str(env.observation_space))

    for r in range(100):
        log("reset " + str(r))
        env.reset()
        steps = 0

        done = False
        while not done:
            steps += 1
            action = env.action_space.sample()
            log(str(steps) + " action: " + str(action))
            obs, reward, done, info = env.step(action)
            log(str(steps) + " reward: " + str(reward))
            log(str(steps) + " observation: " + str(obs))
            # log("reward: " + str(reward))
            # log("done: " + str(done))
            # log("info: " + str(info))
            # log(" obs: " + str(obs))

            time.sleep(.05)

    env.close()

threads = [Thread(target=run, args=(i,)) for i in range(2)]

# start 2 agents
[t.start() for t in threads]
[t.join() for t in threads]
